require "Cocos2d"
require "CocoStudio"
require "GuiConstants"
require "Cocos2dConstants"
require "json"
require "AudioEngine"

function __G__TRACKBACK__(msg)
    print("----------------------------------------")
    print("LUA ERROR: " .. tostring(msg) .. "\n")
    print(debug.traceback())
    print("----------------------------------------")
end

LuaInterFace = LuaInterFace or {};

M_PI = 3.14159265358979323846264338327

local _strLocalTable = {
coin_lack = {
        zh = [[Ҳ]],
        tw = [[Ų]],
        en = [[Insufficient coins]]
    },
}

function LuaInterFace.getLocalString(key)
    va = _strLocalTable[key]
    local lan = LuaInterFace.GetAppLan()

    if  va then
        if lan == 1 then
            return va.zh
        elseif lan == 16 then
            return va.tw
        else
            return va.en
        end
    else
        return key
    end
end

--    ȡǰİ汾(Ϊ˼ݾɰ汾,ֵԶ120,4.35İ汾Ч)
function LuaInterFace.GetLuaVersion()
    return 120; 
end
--    ȡǰ
function LuaInterFace.GetActiveMainLayer()
    return LuaActiveLayer:GetActiveMainLayer()
end

--ȡǰ·
function LuaInterFace.GetCurActivePath()
    return  LuaActiveLayer:getInstance():GetCurActivePath()
end

--ȡǰûID
function LuaInterFace.GetUserId()
    return LuaActiveLayer:getInstance():GetUserId()
end

--ȡǰû
function LuaInterFace.GetUserName()
    return  LuaActiveLayer:getInstance():GetUserName()
end

--ȡǰûʱ
function LuaInterFace.GetUserTmpPassword()
    return LuaActiveLayer:getInstance():GetUserTmpPassword()
end

--Ƿ׳ :varName "userFirstReg""" 
function LuaInterFace.GetUserInfo_Int64(varName)
    return LuaActiveLayer:getInstance():GetUserInfo_Int64(varName)
end

--ȡûmac
function LuaInterFace.GetUserMac()
    return LuaActiveLayer:getInstance():GetUserMac()
end

--ȡƽ̨
function LuaInterFace.GetUserChanelName()
    return LuaActiveLayer:getInstance():GetUserChanelName()
end

--ȡ
function LuaInterFace.GetAppLan()
    return LuaActiveLayer:getInstance():GetAppLan()
end

--ȡ豸
function LuaInterFace.GetDeviceType()
    return LuaActiveLayer:getInstance():GetDeviceType()
end

--ȡͻ˰汾
function LuaInterFace.GetUserAppVersion()
    return LuaActiveLayer:getInstance():GetUserAppVersion()
end

--ȡǰͻµİ汾
function LuaInterFace.GetNewAppVersion()
    return LuaActiveLayer:getInstance():GetNewAppVersion()
end

--°汾ĸ
function LuaInterFace.GetNewVersionStr()
    return LuaActiveLayer:getInstance():GetNewVersionStr()
end

--°汾صַ
function LuaInterFace.GetNewAppUrl()
   return LuaActiveLayer:getInstance():GetNewAppUrl()
end

--°汾
function LuaInterFace.DownNewApp()
    LuaActiveLayer:getInstance():DownNewApp()
end

--ȡǰûõ
function LuaInterFace.GetBestCueType()
    return LuaActiveLayer:getInstance():GetBestCueType()
end

--ûϢ
function LuaInterFace.UpUserData()
    LuaActiveLayer:getInstance():UpUserData()
end

--վӿgetʽ صluaHttpRequestWeb
function LuaInterFace.GetHttpData(mark, url)
     LuaActiveLayer:getInstance():GetHttpData(mark, url)
end

--վӿpostʽ صluaHttpRequestWeb
function LuaInterFace.PostHttpData(mark, url, postData, length)
    LuaActiveLayer:getInstance():PostHttpData(mark, url, postData, length)
end

--[[
ťϢʾ
dlgTag     intͱ
title      ʾַ
msg        ʾַ
firstBtStr һťַǩ
secondBtStrڶťַǩ
delTag     Ҫɾģ̬inttag

ťصluaBtPressMsgOne luaBtPressMsgTwo
--]]
function LuaInterFace.ShowMsgDlg(dlgTag, title, msg, firstBtStr, secondBtStr, delTag)
    LuaActiveLayer:getInstance():ShowMsgDlg(dlgTag, title, msg, firstBtStr, secondBtStr, delTag)
end

--[[
ťʾ
dlgTag     intͱ
msg        ʾַ
tipType    ʾ0  1 2 3Ϣ 4
delTag     Ҫɾģ̬inttag
--]]
function LuaInterFace.ShowTipsDlg(dlgTag, msg, tipType, delTag)
    LuaActiveLayer:getInstance():ShowTipsDlg(dlgTag, msg, tipType, delTag)
end

--[[
loading ģ̬:
dlgTag     intͱ
msg        loadingַ
timeOut    Ԥ賬ʱʱ
delTag      Ҫɾģ̬inttag

ʱص:luaLoadTimeOut
--]]

function LuaInterFace.ShowLoadDlg(dlgTag, msg, timeOut, delTag)
    LuaActiveLayer:getInstance():ShowLoadDlg(dlgTag, msg, timeOut, delTag)
end

--[[
رģ̬ (ֶɹر):
tag     Ҫرյģ̬inttag
--]]
function LuaInterFace.CloseModalLayer(tag)
    LuaActiveLayer:getInstance():CloseModalLayer(tag)
end

--[[

json   Ʒбjsonַ
type   true ͨý false ƷĽ
--]]
function LuaInterFace.ShowExchangeTips(json, bNormal)
    if bNormal then
       LuaActiveLayer:getInstance():ShowNewRewardLayer(json)
    else
       LuaActiveLayer:getInstance():ShowExchangeTips(json)
    end
end

--[[
תӿڲ:
faceType intͽ
0,				//޹;
1,				//1v1ģʽ;
2,				//8˱;
3,				//14-1ģʽ;
4,				//СϷ;
5,				//;
6,				//ȡ;
7,				//ҵ;
8,				//ھ֮·ؿ;
9,				//ھ֮·;
10,				//ھ֮·װ;
11,				//˹ŵ˶սģʽ;
12,				//28СϷ;
13,				//ֵ޹;
14,				//Ѱ;
15,				//;
16,				//߹;
17,				//ǩ;
18,				//ֵʯ;
19,				//;
20,				//;
--]]

function LuaInterFace.ChangeToModeLayer(faceType)
    LuaActiveLayer:getInstance():ChangeToModeLayer(faceType)
end

--ҳлҳ
function LuaInterFace.PublicChangeToGuide()
    LuaActiveLayer:getInstance():PublicChangeToGuide()
end

--[[
ȡҳ int
0   ҳ
1   ҳ
--]]

function LuaInterFace.GetActiveLayerType()
    return LuaActiveLayer:getInstance():GetActiveLayerType()
end

--Ч
function LuaInterFace.PlayerEffect(effect)
   LuaActiveLayer:getInstance():PlayerEffect(effect)
end

--ȡ
function LuaInterFace.GetTtfFont()
    return LuaActiveLayer:getInstance():GetTtfFont()
end

--رջ
function LuaInterFace.CloseActiveLayer()
    LuaActiveLayer:getInstance():CloseActiveLayer()
end

--ȡͷ΢
function LuaInterFace.GetStrKfWeiXin()
    return LuaActiveLayer:getInstance():GetStrKfWeiXin()
end

--ȡͷqq
function LuaInterFace.GetStrKfQQ()
    return LuaActiveLayer:getInstance():GetStrKfQQ()
end

--Ϣ  intid ַ
function LuaInterFace.GetTaskDec(taskId)
    return LuaActiveLayer:getInstance():GetTaskDec(taskId)
end

--ǰĽ  intid int
function LuaInterFace.GetTaskProgress(taskId)
    return LuaActiveLayer:getInstance():GetTaskProgress(taskId)
end

--Ŀ  intid int
function LuaInterFace.GetTaskTotal(taskId)
    return LuaActiveLayer:getInstance():GetTaskTotal(taskId)
end

--Ľ  intid int
function LuaInterFace.GetTaskRewardCount(taskId)
    return LuaActiveLayer:getInstance():GetTaskRewardCount(taskId)
end

--ȡ  int͵id ַ
function LuaInterFace.GetPropName(propId)
    return LuaActiveLayer:getInstance():GetPropName(propId)
end

--ȡIcon  int͵id int͵ ַ
function LuaInterFace.GetPropIcon(propId, count)
    return LuaActiveLayer:getInstance():GetPropIcon(propId, count)
end

--ȡMD5Str  ַ ַ
function LuaInterFace.GetMD5String(md5Str)
    return LuaActiveLayer:getInstance():GetMD5String(md5Str)
end

--ȡʱ   ַ
function LuaInterFace.GetServerTime()
    return LuaActiveLayer:getInstance():GetServerTime()
end

--ַ(bLoc:ǷҪhosturl);
function LuaInterFace.OpenURLInWeb(url, bLoc)
    LuaActiveLayer:getInstance():OpenURLWithWeb(url, bLoc)
end

--Ƕҳwebַ(bLoc:ǷҪhosturl);
function LuaInterFace.DisplayWebInView(url, bLoc)
    if LuaInterFace.GetUserAppVersion() >= 400 then
        LuaActiveLayer:getInstance():DisplayWebInView(url, bLoc)
	else
		LuaActiveLayer:getInstance():OpenURLWithWeb(url, bLoc)
    end
end

--ȡѾ븸ڵ˽ڵ
function LuaInterFace.getCueWithId(cueId, pos, scale)
    if LuaInterFace.GetUserAppVersion() >= 386 then
        return LuaActiveLayer:getInstance():getCueWithId(cueId, pos, scale)
    else
      local cueSp = cc.Sprite:create(LuaInterFace.addImgFile(string.format("OtherImage.bundle/AllCue/BallDeskLayer_Cue%d.png",cueId)))
      return cueSp
    end
end

--ü
function LuaInterFace.getClipNode(rc, iRadius, bTopNoClip)
    if LuaInterFace.GetUserAppVersion() >= 388 then
       return LuaActiveLayer:getInstance():getClipNode(rc, iRadius, bTopNoClip)
    else
       local pClipping = cc.ClippingNode:create()
       pClipping:setInverted(false)

       local pStenCil = cc.DrawNode:create()
       pStenCil:drawRect(cc.p(rc.getMinX(), rc.getMinY), cc.p(rc.getMaxX(), rc.getMinY), cc.p(rc.getMinX(), rc.getMaxY()), cc.p(rc.getMaxX(), rc.getMaxY()))
       pClipping:setStencil(pStenCil)

       return pClipping

    end
end

--plistļ
function LuaInterFace.addListFile(plistName)
	if LuaInterFace.GetUserAppVersion() >= 396 then
        LuaActiveLayer:getInstance():addListFile(plistName)
	else
		if(string.find(plistName, LuaActiveLayer:getInstance():GetCurActivePath()) ~= nil) then
			LuaActiveLayer:getInstance():addListFile(plistName)
		else
			LuaActiveLayer:getInstance():addListFile(LuaActiveLayer:getInstance():GetCurActivePath()..plistName)
		end
	end
end

--imgļ
function LuaInterFace.addImgFile(imgName)
	if LuaInterFace.GetUserAppVersion() >= 396 then
        return LuaActiveLayer:getInstance():addImgFile(imgName)
	else
		if(string.find(imgName, LuaActiveLayer:getInstance():GetCurActivePath()) ~= nil) then
			return LuaActiveLayer:getInstance():addImgFile(imgName)
		else
			return LuaActiveLayer:getInstance():addImgFile(LuaActiveLayer:getInstance():GetCurActivePath()..imgName)
		end
	end
end

--UIļ
function LuaInterFace.addUiFile(uiName)
	if LuaInterFace.GetUserAppVersion() >= 396 then
        return LuaActiveLayer:getInstance():addUiFile(uiName)
	else
		if(string.find(uiName, LuaActiveLayer:getInstance():GetCurActivePath()) ~= nil) then
			return LuaActiveLayer:getInstance():addUiFile(uiName)
		else
			return LuaActiveLayer:getInstance():addUiFile(LuaActiveLayer:getInstance():GetCurActivePath()..uiName)
		end
	end
end

--plistļ
function LuaInterFace.addListFileEx(plistName, bloc)
	if LuaInterFace.GetUserAppVersion() > 397 then
        LuaActiveLayer:getInstance():addListFile(plistName, bloc)
	end
end

--imgļ
function LuaInterFace.addImgFileEx(imgName, bloc)
	if LuaInterFace.GetUserAppVersion() > 397 then
        return LuaActiveLayer:getInstance():addImgFile(imgName, bloc)
	end
	return ""
end

--UIļ
function LuaInterFace.addUiFileEx(uiName, bloc)
	if LuaInterFace.GetUserAppVersion() > 397 then
        return LuaActiveLayer:getInstance():addUiFile(uiName, bloc)
	end
	return nil
end

--
function LuaInterFace.CreateCueWithId(cueId)
    if LuaInterFace.GetUserAppVersion() >= 392 then
        return LuaActiveLayer:getInstance():CreateCueWithId(cueId)
    else
        local cueSp = cc.Sprite:create(LuaInterFace.addImgFile(string.format("OtherImage.bundle/AllCue/BallDeskLayer_Cue%d.png",cueId)))
        return cueSp
    end
end

--
function LuaInterFace.CreateCueWithIdAndSkin(cueId, iSkin)
    if LuaInterFace.GetUserAppVersion() >= 418 then
        return LuaActiveLayer:getInstance():CreateCueWithIdAndSkin(cueId, iSkin)
    else
        return LuaInterFace.CreateCueWithId(cueId)
    end
end


--ʾҳֵ
function LuaInterFace.ShowRechargeCoin(bPress)
    if LuaInterFace.GetUserAppVersion() >= 392 then
        LuaActiveLayer:getInstance():ShowRechargeCoin(bPress)
    else
        LuaActiveLayer:getInstance():ShowTipsDlg(20000, LuaInterFace.getLocalString("coin_lack"), 1, -1)
    end
end

--ʾʯֵ
function LuaInterFace.ShowRechargeGem(bPress)
    if LuaInterFace.GetUserAppVersion() >= 392 then
        LuaActiveLayer:getInstance():ShowRechargeGem(bPress)
    else
        LuaActiveLayer:getInstance():ShowGemLayer()
    end
end

--ûͷ
function LuaInterFace.GetUserHead(userId, bHaveExInfo, iSex, iHead, iHeadFrame, vipType)
	if LuaInterFace.GetUserAppVersion() >= 423 then
		return LuaActiveLayer:getInstance():GetUserHeadSprite(userId);
    elseif (LuaInterFace.GetUserAppVersion() >= 396 and LuaInterFace.GetUserAppVersion() <= 416) then
        return LuaActiveLayer:getInstance():GetUserHead(userId, bHaveExInfo, iSex, iHead, iHeadFrame, vipType);
    else
        local headSp = cc.Sprite:createWithSpriteFrameName("Head (0).png")
        return headSp
    end
end

--ûϢ
function LuaInterFace.AddUserInfo(userId, userName, iHead, iHeadFrame, vipType)
	if LuaInterFace.GetUserAppVersion() >= 423 then
		LuaActiveLayer:getInstance():AddUserInfo(userId, userName, iHead, iHeadFrame, vipType);
    end
end

--ʾ
function LuaInterFace.ShowPropDescribe(propId)
    if LuaInterFace.GetUserAppVersion() >= 400 then
        LuaActiveLayer:getInstance():ShowPropDescribe(propId)
    end
end

--ͳϢ s_OtherCueMake˵Ĵ
function LuaInterFace.AddStatisticsCount(statisName, iCount)
    if LuaInterFace.GetUserAppVersion() >= 400 then
        LuaActiveLayer:getInstance():AddStatisticsCount(statisName, iCount)
    end
end

--õϢ moneyҼ۸ diamondʯ۸ itemcount
function LuaInterFace.getPropInfo(propId, infoName)
    if LuaInterFace.GetUserAppVersion() >= 400 then
        return LuaActiveLayer:getInstance():getPropInfo(propId, infoName)
    end
	return "0"
end

--ʾûϢ
function LuaInterFace.ShowUserInterface(userId)
    if LuaInterFace.GetUserAppVersion() >= 420 then
		LuaActiveLayer:getInstance():ShowUserInterface(userId)
    end
end

--ת
function LuaInterFace.ShowPrizeMatchRoom(matchId, roomName)
    if LuaInterFace.GetUserAppVersion() >= 439 then
		LuaActiveLayer:getInstance():ShowPrizeMatchRoom(matchId, roomName)
	elseif LuaInterFace.GetUserAppVersion() >= 422 then
		LuaActiveLayer:getInstance():ShowPrizeMatch(matchId)
    end
end

--֪ͨȨʾ
function LuaInterFace.ActiveShowPushNotice()
    if LuaInterFace.GetUserAppVersion() >= 436 then
		LuaActiveLayer:getInstance():ActiveShowPushNotice()
		return true;
    end
	return false;
end

--ûicon
function LuaInterFace.SetActiveIconId(activeId, iconId)
    if LuaInterFace.GetUserAppVersion() >= 436 then
		LuaActiveLayer:getInstance():SetActiveIconId(activeId, iconId)
    end
end

--ļʵ·
function LuaInterFace.getFileRealPath(fileName)
    if LuaInterFace.GetUserAppVersion() >= 436 then
		return LuaActiveLayer:getInstance():getFileRealPath(fileName)
    end
	return fileName;
end

--ʾ
function LuaInterFace.ShowGiftLayer(userId)
    if LuaInterFace.GetUserAppVersion() >= 438 then
		LuaActiveLayer:getInstance():ShowGiftLayer(userId)
	else
		LuaActiveLayer:getInstance():ShowUserInterface(userId)
    end
end